<script lang="ts">
import Vue from 'vue';
import { SITE_URL } from '~/common/constants';

export default Vue.extend({
  name: 'ShareButtons',
  data() {
    return {
      facebookUrl: '',
      twitterUrl: '',
      linkedInUrl: '',
      threadsUrl: '',
      hackerNewsUrl: '',
    };
  },
  mounted() {
    const siteUrl = encodeURIComponent(
      `${SITE_URL}${window.location.pathname}`,
    );
    const title = encodeURIComponent(window.document.title);
    this.facebookUrl = `http://www.facebook.com/sharer.php?u=${siteUrl}`;
    this.twitterUrl = `https://twitter.com/intent/tweet?text=Check+out+${title}&url=${siteUrl}`;
    this.linkedInUrl = `https://www.linkedin.com/shareArticle?mini=true&url=${siteUrl}&title=${title}&summary=&source=`;
    this.hackerNewsUrl = `https://news.ycombinator.com/submitlink?u=${siteUrl}&t=Check%20out%20${title}`;
    this.threadsUrl = `https://www.threads.net/intent/post?text=${siteUrl}`;
  },
});
</script>

<template>
  <div class="share">
    <SlpTypography class="slp-pb-16" variant="all-caps" tag="h5">{{
      $t('share')
    }}</SlpTypography>
    <div class="share__buttons">
      <a
        :href="twitterUrl"
        target="_blank"
        data-toggle="tooltip"
        title="Share on twitter"
        data-ga-name="twitter"
        data-ga-location="body"
      >
        <SlpIcon name="twitter-x" variant="marketing" />
      </a>
      <a
        :href="linkedInUrl"
        target="_blank"
        data-toggle="tooltip"
        title="GitLab on LinkedIn"
        data-ga-name="linkedin"
        data-ga-location="body"
      >
        <SlpIcon name="linkedin" variant="marketing" />
      </a>
      <a
        :href="facebookUrl"
        target="_blank"
        data-toggle="tooltip"
        title="GitLab on Facebook"
        data-ga-name="facebook"
        data-ga-location="body"
      >
        <SlpIcon name="facebook" variant="marketing" />
      </a>
      <a
        :href="hackerNewsUrl"
        class="social-link linkedin-link"
        target="_blank"
        data-toggle="tooltip"
        title="GitLab on YouTube"
        data-ga-name="hacker news"
        data-ga-location="body"
      >
        <SlpIcon name="hackernews" variant="marketing" />
      </a>

      <a
        :href="threadsUrl"
        class="social-link"
        data-toggle="tooltip"
        data-ga-name="threads"
        data-ga-location="body"
      >
        <SlpIcon color="#000" name="threads" variant="marketing" />
      </a>
    </div>
  </div>
</template>

<style scoped lang="scss">
.share {
  background: $color-surface-100;
  padding: $spacing-24;
  border-radius: 8px;
  width: 100%;

  &__buttons {
    display: flex;
    gap: $spacing-24;
    padding-top: $spacing-16;
    border-top: 1px solid $color-surface-300;

    .slp-icon {
      width: 24px !important;
      height: 24px !important;
    }
  }
}
</style>
